//////////////////////////////
// gdx_indi.c
// written by Michael Gibson
// released under the GPl
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 char indi_check[55];
 char indi_num[6];
 char filename[55];

 char data_line[9999][99];
 int number_of_lines=0;

// char indi_refn[95];     //REFN =reference(user-defined key)
// int  indi_refn_t;
 char indi_name[95];     //NAME = first middle last(surname) name
 int  indi_name_t;
 char indi_titl[95];
 int  indi_titl_t;
 char indi_sex[7];
 int  indi_sex_t;
 char indi_dscr[95];
 int  indi_dscr_t;
 char indi_note[95];
 int  indi_note_t;

 char indi_birt_date[90];
 int  indi_birt_date_t;
 char indi_birt_plac[90];
 int  indi_birt_plac_t;
 char indi_birt_note[95];
 int  indi_birt_note_t;

 char indi_deat_date[90];
 int  indi_deat_date_t;
 char indi_deat_plac[90];
 int  indi_deat_plac_t;
 char indi_deat_note[95];
 int  indi_deat_note_t;

 char indi_addr[95];
 int  indi_addr_t;
 char indi_educ[95];
 int  indi_educ_t;
 char indi_occu[95];
 int  indi_occu_t;
 char indi_reli[95];
 int  indi_reli_t;

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}


////////////////////////////////////////////////////
//// family
///////////////////////////////////////////////////
static void family(void)
{

  char systemstring[164];

  sprintf(systemstring,"./gedchild %s %s 1 &",indi_check,filename);
  system(systemstring);
}
////////////////////////////////////////////////////
//
///////////////////////////////////////////////////
void parent(void)
{

  char systemtext[60];

  sprintf(systemtext,"./gedtree %s %s &",filename, indi_check);

  system(systemtext);

}

void help(void)
{
 
  x_imgbox("images/helptext.xpm","Help");

}


//////////////////////////////
// save
// save individual data
/////////////////////////////
void save(void)
{
  FILE *fp;
  int data_written=0;
  int occu_written=0;
  int occu_needs_written=0;
  int titl_written=0;
  int titl_needs_written=0;
  int dscr_written=0;
  int dscr_needs_written=0;
  int addr_written=0;
  int addr_needs_written=0;
  int educ_written=0;
  int educ_needs_written=0;
  int reli_written=0;
  int reli_needs_written=0;
  int note_written=0;
  int note_needs_written=0;
  char temp[95];
  char check_string1[15];
  char check_string2[15];
  int x,y; // loop var
  char indi[10];
  int indi_r;
  int write_indi=0;

  //collect data from text entry widgets
  strcpy(indi_occu, gdx_textentry_obj.string[indi_occu_t]);
  strcpy(indi_reli, gdx_textentry_obj.string[indi_reli_t]);
  strcpy(indi_educ, gdx_textentry_obj.string[indi_educ_t]);
  strcpy(indi_addr, gdx_textentry_obj.string[indi_addr_t]);
  strcpy(indi_note, gdx_textentry_obj.string[indi_note_t]);
  strcpy(indi_dscr, gdx_textentry_obj.string[indi_dscr_t]);
  strcpy(indi_titl, gdx_textentry_obj.string[indi_titl_t]);

  if(strlen(indi_occu) >= 2) occu_needs_written=1;
  if(strlen(indi_titl) >= 2) titl_needs_written=1;
  if(strlen(indi_dscr) >= 2) dscr_needs_written=1;
  if(strlen(indi_addr) >= 2) addr_needs_written=1;
  if(strlen(indi_educ) >= 2) educ_needs_written=1;
  if(strlen(indi_reli) >= 2) reli_needs_written=1;
  if(strlen(indi_note) >= 2) note_needs_written=1;

/// now for updated data ///

  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data
  for(x=1;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }

    //1 NAME
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A' && temp[4]=='M' && write_indi==1){
        //if yes, write change
        sprintf(data_line[x],"1 NAME %s\n",indi_name);
        data_written=1;
    }

    //1 TITL
    if(temp[0]=='1' && temp[2]=='T' && temp[3]=='I' && temp[4]=='T' && write_indi==1){
        //if yes, write change
        sprintf(data_line[x],"1 TITL %s\n",indi_titl);
        data_written=1;
        titl_written=1;
    }

    //1 OCCU 
    if(temp[0]=='1' && temp[2]=='O' && temp[3]=='C' && temp[4]=='C' && write_indi==1){
        //if yes, write change   
        sprintf(data_line[x],"1 OCCU %s\n",indi_occu);
        data_written=1;
        occu_written=1;
    }

    //1 EDUC
    if(temp[0]=='1' && temp[2]=='E' && temp[3]=='D' && temp[4]=='U' && write_indi==1){
       //if yes, write change
       sprintf(data_line[x],"1 EDUC %s\n",indi_educ);
       data_written=1;
       educ_written=1;
    }

    //1 ADDR
    if(temp[0]=='1' && temp[2]=='A' && temp[3]=='D' && temp[4]=='D' && write_indi==1){
       //if yes, write change
       sprintf(data_line[x],"1 ADDR %s\n",indi_addr);
       data_written=1;
       addr_written=1;
    }

    //1 RELI
    if(temp[0]=='1' && temp[2]=='R' && temp[3]=='E' && temp[4]=='L' && write_indi==1){
        //if yes, write change
        sprintf(data_line[x],"1 RELI %s\n",indi_reli);
       data_written=1;
       reli_written=1;
    }

    //1 NOTE
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='O' && temp[4]=='T' && write_indi==1){
        //if yes, write change
        sprintf(data_line[x],"1 NOTE %s\n",indi_note);
        data_written=1;
        note_written=1;
    }

   // 1 DSCR
    if(temp[0]=='1' && temp[2]=='D' && temp[3]=='S' && temp[4]=='C' && write_indi==1){
        //if yes, write change
        sprintf(data_line[x],"1 DSCR %s\n",indi_dscr);
       data_written=1;
       dscr_written=1;
    }

    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

/// Now for new data ////

 if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data
  for(x=1;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }

    //1 OCCU after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&occu_written==0&&occu_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 OCCU %s\n",temp,indi_occu);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 TITL after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&titl_written==0&&titl_needs_written==1){
        //if yes, write change
       sprintf(temp,"%s1 TITL %s\n",temp,indi_titl);
       strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 DSCR after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&dscr_written==0&&dscr_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 DSCR %s\n",temp,indi_dscr);
        strcpy(data_line[x],temp); 
        data_written=1;
    }

    //1 ADDR after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&addr_written==0&&addr_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 ADDR %s\n",temp,indi_addr);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 EDUC after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&educ_written==0&&educ_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 EDUC %s\n",temp,indi_educ);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 RELI after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&reli_written==0&&reli_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 RELI %s\n",temp,indi_reli);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 NOTE after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&note_written==0&&note_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 NOTE %s\n",temp,indi_note);
        strcpy(data_line[x],temp);
        data_written=1;
    }



    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);




  if(data_written==1) x_msgbox(5,"Data has been saved","Saved","fixed",50);

}


//////////////////////////////////
// add spouce
////////////////////////////////////////
void add_spouce(void)
{
  char spouce_string[90];
  if(indi_sex[0]=='F')
    sprintf(spouce_string,"./gedadd_spouce %s %s M",indi_check,filename);
  if(indi_sex[0]=='M')
    sprintf(spouce_string,"./gedadd_spouce %s %s F",indi_check,filename);
  system(spouce_string);

  printf("indi sex='%c' and spouce string='%s' \n",indi_sex[0],spouce_string);
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char last_action[15];


  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int button_06, button_07;
  int label0,label1,label2,label3,label4,label5,label6;
  int label7,label8,label9,label10,label11, label12, label13;
  int label14, label15;
  int readflag=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_num, argv[2]);
  strcpy(indi_note,"\0");
  strcpy(indi_birt_plac,"\0");
  strcpy(indi_deat_plac,"\0");
  strcpy(indi_deat_date,"\0");
  strcpy(indi_addr,"\0"); 
  strcpy(indi_educ,"\0");
  strcpy(indi_occu,"\0");
  strcpy(indi_reli,"\0");
  strcpy(indi_titl,"\0");
  strcpy(indi_dscr,"\0");

  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual",550,500);
  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(35,18,530,460,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_06 = gdx_imagebutton(5,50,"images/filesave.xpm",save);
  button_02 = gdx_imagebutton(5,75,"images/pari.xpm",parent);
  button_03 = gdx_imagebutton(5,100,"images/chil.xpm",family);
  button_04 = gdx_imagebutton(5,125,"images/marr.xpm",add_spouce);
  button_05 = gdx_imagebutton(5,175,"images/help.xpm",help);

  label0 = gdx_label(argv[2],222,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  //main start of read

  do{
    //check for level 0
    fgets(input1,80,fp5);

    //store all data for later use
    strcpy(data_line[loopy],input1);
    loopy++;

     //01234567890123
     //0 @I0001@ INDI
     if(input1[0]=='0'&& input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){

        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          readflag=1;
        }
        else readflag=0;
     }// end if indi found

      if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A' && readflag==1){     ///1 NAME
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_name,input1);
      }

      if(input1[0]=='1' && input1[2]=='T' && input1[3]=='I' && input1[4]=='T' && readflag==1){     ///1 TITL
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_titl,input1);
      }

      if(input1[0]=='1' && input1[2]=='N' && input1[3]=='O' && readflag==1){     ///1 NOTE
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_note,input1);
      }

      if(input1[0]=='1' && input1[2]=='D' && input1[3]=='S'&&readflag==1){     ///1 DSCR
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_dscr,input1);
      }

      if(input1[0]=='1' && input1[2]=='S' && input1[3]=='E' &&readflag==1){   ///1 SEX
        indi_sex[0]=input1[6];
        indi_sex[1]='\0';
      }
// last actions

      if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H' && input1[4] =='A' &&readflag==1){ //1 CHAN
         strcpy(last_action,"CHAN");
      }

      if(input1[0]=='1' && input1[2]=='E' && input1[3]=='V' && input1[4] =='E'&&readflag==1){ //1 EVEN
         strcpy(last_action,"EVEN");
      }

      if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'&&readflag==1){ //1 BURI
        strcpy(last_action,"BURI");
      }

      if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'&&readflag==1){ //1 CREM
        strcpy(last_action,"CREM");
      }

      if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I'&&readflag==1){ //1 BIRT
         strcpy(last_action,"BIRT");
      }

      if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'&&readflag==1){ //1 DEAT
        strcpy(last_action,"DEAT");
      }

// Birth Date and Death Date

       if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'&&readflag==1){ //2 DATE
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='I'&&readflag==1){
            strcpy(indi_birt_date,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_date,input1);
          }
       }

// Brith Place and Death Place
 
       if(input1[0]=='2' && input1[2]=='P' && input1[3]=='L'&&readflag==1){ //2 PLAC
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='I'&&readflag==1){
            strcpy(indi_birt_plac,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_plac,input1);
          }
       }


// Brith Note and Death Note

       if(input1[0]=='2' && input1[2]=='N' && input1[3]=='O'&&readflag==1){ //2 Note 
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='I'&&readflag==1){
            strcpy(indi_birt_note,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_note,input1);
          }
       }



/// Address
        if(input1[0]=='1' && input1[2]=='A' && input1[3]=='D' && input1[4]=='D' && input1[5]=='R' && readflag==1){    
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_addr,input1);
        }

// Occupation
        if(input1[0]=='1' && input1[2]=='O' && input1[3]=='C' &&readflag==1){   
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_occu,input1);
        }

// Education
        if(input1[0]=='1' && input1[2]=='E' && input1[3]=='D' &&readflag==1){    
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_educ,input1);
        }

// Religon
       if(input1[0]=='1' && input1[2]=='R' && input1[3]=='E' && readflag==1){   
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_reli,input1);
       }

  }while(input1[0] !='0' || input1[2] !='T');

  number_of_lines=loopy;

  //display
  //Name
  label1 = gdx_label("Name:",40,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(125,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);
  gdx_image(380,25,"images/update.xpm");

  label2 = gdx_label("Title:",40,60,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_titl_t=gdx_textentry(125,50,200,0);
  gdx_settextentry(indi_titl_t,indi_titl);
  if(indi_titl[0]=='\0')gdx_image(330,50,"images/tree_info.xpm");
  else gdx_image(330,50,"images/update.xpm");

  //Sex
  label3=gdx_label("Sex:",40,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_sex_t=gdx_textentry(125,75,20,0);
  gdx_settextentry(indi_sex_t,indi_sex);

  //Dascription
  label4=gdx_label("Description:",40,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_dscr_t=gdx_textentry(125,100,350,0);
  gdx_settextentry(indi_dscr_t,indi_dscr);
  if(indi_dscr[0]=='\0') gdx_image(480,100,"images/tree_info.xpm");
  else gdx_image(480,100,"images/update.xpm");

  label13 = gdx_label("Occupation:",40,135,0);
  gdx_setlabelbg("images/bg.xpm",1,label13);
  indi_occu_t=gdx_textentry(125,125,350,0);
  gdx_settextentry(indi_occu_t,indi_occu);
  if(indi_occu[0]=='\0') gdx_image(480,125,"images/tree_info.xpm");
  else gdx_image(480,125,"images/update.xpm");

  label14 = gdx_label("Education:",40,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label14);
  indi_educ_t=gdx_textentry(125,150,350,0);
  gdx_settextentry(indi_educ_t,indi_educ);
  if(indi_educ[0]=='\0') gdx_image(480,150,"images/tree_info.xpm");
  else gdx_image(480,150,"images/update.xpm");

  label15 = gdx_label("Religon:",40,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label15);
  indi_reli_t=gdx_textentry(125,175,350,0);
  gdx_settextentry(indi_reli_t,indi_reli);
  if(indi_reli[0]=='\0') gdx_image(480,175,"images/tree_info.xpm");
  else gdx_image(480,175,"images/update.xpm");

  label12 = gdx_label("Address:",40,210,0);
  gdx_setlabelbg("images/bg.xpm",1,label12);
  indi_addr_t=gdx_textentry(125,200,350,0);
  gdx_settextentry(indi_addr_t,indi_addr);
  if(indi_addr[0]=='\0') gdx_image(480,200,"images/tree_info.xpm");
  else gdx_image(480,200,"images/update.xpm");

  label5 = gdx_label("General Note:",40,235,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_note_t=gdx_textentry(125,225,350,0);
  gdx_settextentry(indi_note_t,indi_note);
  if(indi_note[0]=='\0') gdx_image(480,225,"images/tree_info.xpm");
  else gdx_image(480,225,"images/update.xpm");

  //Birth Date
  label6=gdx_label("Birth Date:",40,285,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_birt_date_t=gdx_textentry(125,275,100,0);
  gdx_settextentry(indi_birt_date_t,indi_birt_date);

  //Birth Place
  label7=gdx_label("Birth Place:",40,310,0);
  gdx_setlabelbg("images/bg.xpm",1,label7);
  indi_birt_plac_t=gdx_textentry(125,300,350,0);
  gdx_settextentry(indi_birt_plac_t,indi_birt_plac);

  label8 = gdx_label("Birth Note:",40,335,0);
  gdx_setlabelbg("images/bg.xpm",1,label8);
  indi_birt_note_t=gdx_textentry(125,325,350,0);
  gdx_settextentry(indi_birt_note_t,indi_birt_note);


  //Death Date
  label9=gdx_label("Death Date:",40,385,0);
  gdx_setlabelbg("images/bg.xpm",1,label9);
  indi_deat_date_t=gdx_textentry(125,375,100,0);
  gdx_settextentry(indi_deat_date_t,indi_deat_date);

  //Death Place
  label10=gdx_label("Death Place:",40,410,0);
  gdx_setlabelbg("images/bg.xpm",1,label10);
  indi_deat_plac_t=gdx_textentry(125,400,350,0);
  gdx_settextentry(indi_deat_plac_t,indi_deat_plac);

  label11 = gdx_label("Death Note:",40,435,0);
  gdx_setlabelbg("images/bg.xpm",1,label11);
  indi_deat_note_t=gdx_textentry(125,425,350,0);
  gdx_settextentry(indi_deat_note_t,indi_deat_note);

  gdx_main();
  x_close();

  return(0);
}

