//////////////////////////////
// add_child.c
// written by Michael Gibson
// released under the GPL
// enter the child of a family
// copyright 2007
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"


char *error_msg;

////////////////////////
//// error message
////////////////////////
void quick_message(void) {

  x_msgbox(5,error_msg,"Error","fixed",50);

}

 void readfile(void);
 void writefile(void);

 char indi_name_s[95];
 int  indi_name;
 char indi_sname_s[95];
 int  indi_sname;
 char indi_title_s[95];
 int  indi_title;
 char indi_gnote_s[95];
 int  indi_gnote;
 char indi_sex_s[7];
 int  indi_sex;

 char indi_birthdate_s[90];
 int  indi_birthdate;
 char indi_birthplace_s[90];
 int  indi_birthplace;
 char indi_birthnote_s[90];
 int  indi_birthnote;

 char indi_deathdate_s[90];
 int  indi_deathdate;
 char indi_deathplace_s[90];
 int  indi_deathplace;
 char indi_deathnote_s[90];
 int  indi_deathnote;


 char indi_check[55];
 int fam_passed;             //family read/passed in
 int last_read_indi;
 int newid;                   //id of the individual being added
 int last_read_fami;

 char filename[55];
 char temp[80];               //data that is read in and evaluated

 int number_of_names;
 int number_of_lines;
 int family_begin;
 int x; //loop var

 //for up to 99999 lines read in at the length up to 80
 char data_line[99999][80];

 int lastchild;
 int mother_id;

////////////////////////////////////////
//
//////////////////////////////////////
static void submit(void)
{

  char string_1[50];

  //printf("submit pressed \n");

  writefile();

  system("killall gedlist");
  sprintf(string_1,"./gedlist %s &",filename);
  //printf("%s\n",string_1);
  system(string_1);
  exit(0);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){


  int  child_image;

  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03;
  int label0,label1,label2,label3,label4,label5,label6,label7;
  int label8,label9,label10,label11,label12,label13,label14,label15;
  char label_string1[60];
  char label_string2[60];
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[2]);
  readfile();

  //printf("Start GUI\n");

  system("killall gedtree");
  x_open();

  /* create a new window */
  gdx_window("GEDCOM Add Child",500,450);
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,25,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,50,"images/filesave.xpm",submit);
  button_03 = gdx_imagebutton(35,410,"images/submit.xpm",submit);

  child_image=gdx_image(120,35, "images/addchild2.xpm");  

  sprintf(label_string1,"Saving to filename %s",argv[2]);
  label0 = gdx_label(label_string1,40,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);


  printf("app=%s family=%s filename=%s lastchildoffamily=%s mother_id=%s\n",argv[0],argv[1],argv[2],argv[3],argv[4]);

  fam_passed=atoi(argv[1]);
  lastchild=atoi(argv[3]);
  mother_id=atoi(argv[4]);
  // entry 

  label1 = gdx_label("Given Name:",35,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name=gdx_textentry(125,75,200,0);

  label2=gdx_label("Surname:",35,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_sname=gdx_textentry(125,100,200,0);

  label3=gdx_label("Title:",35,135,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_title=gdx_textentry(125,125,150,0);

  label4=gdx_label("Sex:",35,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_sex=gdx_textentry(125,150,20,0);
  label5=gdx_label("[M or F]",155,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);

  label6=gdx_label("General Note:",35,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_gnote=gdx_textentry(125,175,350,0);


  label7=gdx_label("Birth Date:",35,235,0);
  gdx_setlabelbg("images/bg.xpm",1,label7); 
  indi_birthdate=gdx_textentry(125,225,100,0);

  label8 = gdx_label("Birth Place:",35,260,0);
  gdx_setlabelbg("images/bg.xpm",1,label8);
  indi_birthplace=gdx_textentry(125,250,250,0);

  label9 = gdx_label("Birth Note:",35,285,0);
  gdx_setlabelbg("images/bg.xpm",1,label9);
  indi_birthnote=gdx_textentry(125,275,350,0);



  label10=gdx_label("Death Date:",35,335,0);
  gdx_setlabelbg("images/bg.xpm",1,label10);
  indi_deathdate=gdx_textentry(125,325,100,0);

  label11=gdx_label("Death Place:",35,360,0);
  gdx_setlabelbg("images/bg.xpm",1,label11);
  indi_deathplace=gdx_textentry(125,350,250,0);

  label12=gdx_label("Death Note:",35,385,0);
  gdx_setlabelbg("images/bg.xpm",1,label12);
  indi_deathnote=gdx_textentry(125,375,350,0);



  gdx_main();
  x_close();

  return(0);
}


////////////////////////////////////////////////////////
// read file
////////////////////////////////////////////////////////

void readfile(void)
{

  int theend=0;      //if end of data found, stop reading

  int familyfound=0; //if a family is found, stop looking

  FILE *fp; 
  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM add parent : Sorry, no file found. \n");
     exit(0);
  }
  number_of_names = 0;
  number_of_lines = 0;
  do{
    fgets(temp,80,fp);
    number_of_lines++;
    strcpy(data_line[number_of_lines],temp);

    //clean up returns
    for(x=0;x<80;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }

    // Look for indivduals
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++){
        if(temp[x]=='@' || temp[x]=='I' ||temp[x]=='N' ||temp[x]=='D') temp[x]=' ';
      }
      last_read_indi=atoi(temp);
      number_of_names++;
    } //end if


   //Look for family start
   if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F' && familyfound==0){
     family_begin=number_of_lines;
     familyfound=1;
   }


   //find end
   if(temp[0] == '0' && temp[2] == 'T' && temp[3] == 'R'){
     theend=1;
   }
  //printf(".");

  }while (theend != 1); //end do

  //printf("\nNumber of lines = %d \n",number_of_lines);
  //printf("Number of names = %d \n",number_of_names);
  //printf("Last read ID=%d \n",last_read_indi);
  newid=last_read_indi + 1;
  //printf("Last read family ID=%d \n",last_read_fami);

  //printf("new person to have ID of %4d \n",newid);
  //printf("Line %d is where families begin \n",family_begin);
  //lastline
}


//////////////////////////////
//
/////////////////////////////
void writefile(void)
{
  char check_string1[15];
  char check_string2[15];
  char check_string3[15];
  int inside_family=0;
  int y; // loop var

  char indi[10];
  int indi_r;

  char chil_string[80];
  char chil_name[80];
  char c_bd[20];
  char c_bp[20];
  char c_bn[80];
  char c_dd[20];
  char c_dp[20];
  char c_dn[80];
  char c_s[4];
  char c_t[20];
  char c_n[80];
  char fam_lnk[20];

  int do_not_save=0;

  //collect data from text entry widgets
  strcpy(indi_name_s, gdx_textentry_obj.string[indi_name]);
  strcpy(indi_sname_s, gdx_textentry_obj.string[indi_sname]);
  if(indi_sname_s[0] == '\0'){
       error_msg = "Did not save data - Surname is required";
       quick_message();
       do_not_save=1;

  }

  strcpy(indi_title_s, gdx_textentry_obj.string[indi_title]);
  strcpy(indi_sex_s, gdx_textentry_obj.string[indi_sex]);

  if(indi_sex_s[0]=='M' || indi_sex_s[0]=='F' || indi_sex_s[0]=='\0'){
    //do_not_save=0;
    printf(" ");    
  }
  else{
       error_msg = "Did not save data - could not write Gender/Sex - Valid entries are:  M for Male.  F for Female."; 
       quick_message();
       do_not_save=1;
  }


  strcpy(indi_gnote_s, gdx_textentry_obj.string[indi_gnote]);

  strcpy(indi_birthdate_s, gdx_textentry_obj.string[indi_birthdate]);

  if(indi_birthdate_s[0] >= 47 && indi_birthdate_s[0]<= 56 || indi_birthdate_s[0] == '\0'){
    //do_not_save=0; 
    printf(" ");
  }
  else{
       error_msg = "Did not save data - could not write Birth Date.  Valid format is: DD MMM YYYY  Example: 10 Jan 1905";
       quick_message();
       do_not_save=1;
  }

  strcpy(indi_birthnote_s, gdx_textentry_obj.string[indi_birthnote]);
  strcpy(indi_birthplace_s, gdx_textentry_obj.string[indi_birthplace]);
  strcpy(indi_deathdate_s, gdx_textentry_obj.string[indi_deathdate]);
  strcpy(indi_deathplace_s, gdx_textentry_obj.string[indi_deathplace]);
  strcpy(indi_deathnote_s, gdx_textentry_obj.string[indi_deathnote]);


if(do_not_save==0){
  //shift data to write one new individuals
  for(x=number_of_lines;x>=family_begin;x--){
    strcpy(data_line[x+14],data_line[x]);
  }

  number_of_lines = number_of_lines +14;

  //format the new data to write
  //format:
  // 0 @I0001@ INDI
  // 1 NAME Billy Bob /Johnson/
  // 1 SEX M
  // 1 TITL Captain
  // 1 BIRT
  // 2 DATE 10 Jun 1959
  // 2 PLAC somewhere
  // 2 NOTE something here
  // 1 DEAT 
  // 2 DATE 12 May 2000
  // 2 PLAC somewhere else
  // 2 NOTE something here also
  // 1 NOTE something here
  // 1 FAMC @F0009@

  sprintf(chil_string,"0 @I%04d@ INDI\n",newid);
  strcpy(data_line[family_begin],chil_string);
  sprintf(chil_name,"1 NAME %s /%s/ \n",indi_name_s,indi_sname_s);
  strcpy(data_line[family_begin+1],chil_name);
  sprintf(c_s,"1 SEX %s\n",indi_sex_s);
  strcpy(data_line[family_begin+2],c_s);
  sprintf(c_t,"1 TITL %s\n",indi_title_s);
  strcpy(data_line[family_begin+3],c_t);
  strcpy(data_line[family_begin+4],"1 BIRT\n");
  sprintf(c_bd,"2 DATE %s \n",indi_birthdate_s);
  strcpy(data_line[family_begin+5],c_bd);
  sprintf(c_bp,"2 PLAC %s \n",indi_birthplace_s);
  strcpy(data_line[family_begin+6],c_bp);
  sprintf(c_bn,"2 NOTE %s \n",indi_birthnote_s);
  strcpy(data_line[family_begin+7],c_bn);
  strcpy(data_line[family_begin+8],"1 DEAT\n");
  sprintf(c_dd,"2 DATE %s \n",indi_deathdate_s);
  strcpy(data_line[family_begin+9],c_dd);
  sprintf(c_dp,"2 PLAC %s \n",indi_deathplace_s);
  strcpy(data_line[family_begin+10],c_dp);
  sprintf(c_dn,"2 NOTE %s \n",indi_deathnote_s);
  strcpy(data_line[family_begin+11],c_dn);
  sprintf(c_n,"1 NOTE %s \n",indi_gnote_s);
  strcpy(data_line[family_begin+12],c_n);
  sprintf(fam_lnk,"1 FAMC @F%04d@\n",fam_passed);
  strcpy(data_line[family_begin+13],fam_lnk);


  FILE *fp;
  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add parent : Sorry, no file found. \n");
     exit(0);
  }


  //write data
  for(x=1;x<=number_of_lines;x++){

    //check for last child of family
    //format:
    ///01234567890123
    ///1 CHIL @I0002@
    //copy to evaluate
    strcpy(temp,data_line[x]);
    sprintf(check_string1,"1 CHIL @I%04d@",lastchild);
    sprintf(check_string2,"1 WIFE @I%04d@",mother_id);


    //01234567
    //0 @F0008@ FAM
    sprintf(check_string3,"0 @F%04d@ FAM",fam_passed);

    //check if we are inside the correct family
    if(strncmp(check_string3,temp,4)==0){
      if(strncmp(check_string3,temp,8)==0) inside_family=1;
      else inside_family=0;
    }

    //if child exist, write after that child
    if(lastchild != 0 && strncmp(check_string1,temp,14)==0) sprintf(data_line[x],"%s1 CHIL @I%04d@\n",temp,newid);

    //if no other child exists in family write after mother
    if(mother_id != 0 && lastchild == 0 && inside_family==1 && strncmp(check_string2,temp,14)==0){
         sprintf(data_line[x],"%s1 CHIL @I%04d@\n",temp,newid);
    }

   //write_data
   // printf("line %d ::%s::",x,data_line[x]);
    fprintf(fp,"%s",data_line[x]);
  }
  fclose(fp);
}//end ok to write
}
